## borgstore 0.1.0

=== debian/changelog ===
borgstore (0.1.0-1) unstable; urgency=medium

  * New upstream version 0.1.0
  * Update package description

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Oct 2024 19:34:04 +0200

borgstore (0.0.5-1) unstable; urgency=medium

  * New upstream version 0.0.5
  * Drop types-requests dependency, removed upstream
  * Update description for new release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 08 Oct 2024 09:13:15 +0200

borgstore (0.0.4-2) unstable; urgency=medium

  * Source-only reupload
  * Add VCS fields

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Oct 2024 19:50:12 +0200

borgstore (0.0.4-1) unstable; urgency=low

  * Initial release (Closes: #1083032)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 30 Sep 2024 10:28:52 +0000
