## borgstore 0.3.0

=== debian/changelog ===
borgstore (0.3.0-2) unstable; urgency=medium

  * Add autopkgtest

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 30 May 2025 10:45:49 +0200

borgstore (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 26 May 2025 17:05:10 +0200

borgstore (0.2.0-1) unstable; urgency=medium

  * Bump copyright years
  * Update copyright url
  * New upstream version 0.2.0
  * Add boto3 new dependency
  * Bump std-version to 4.7.2
  * Sync package description with new release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 25 Apr 2025 16:48:10 +0200
