=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
  dh-python,
  pybuild-plugin-pyproject,
  python3,
+ python3-boto3,
  python3-paramiko,
  python3-requests,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/borgbackup/borgstore
 Vcs-Git: https://salsa.debian.org/debian/borgstore.git
 Vcs-Browser: https://salsa.debian.org/debian/borgstore
@@ -61,8 +62,8 @@
  API can be much simpler:
  .
   - create/destroy: initialize or remove the whole store.
-  - list: flat list of the items in the given namespace, with or without soft
-    deleted items.
+  - list: flat list of the items in the given namespace (by default only not
+    soft deleted items, optionally only soft deleted items).
   - store: write a new item into the store (giving its key/value pair)
   - load: read a value from the store (giving its key), partial loads giving
     offset and/or size are supported.
@@ -75,6 +76,8 @@
     [us]) and lower bandwidth (via BORGSTORE_BANDWIDTH [bit/s]) than what is
     actually provided by the backend.
  .
+ Store operations (and per-op timing and volume) are logged at DEBUG log level.
+ .
  Automatic Nesting
  -----------------
  .
@@ -130,7 +133,6 @@
  - it is the caller's task to create an absolute fs path from a relative one.
  - namespaces: directories
  - values: in key-named files
- - pre-creates nesting directories
  .
  sftp
  ~~~~
@@ -150,7 +152,6 @@
     - users must know the full absolute path of space they have permission to use.
   - namespaces: directories
   - values: in key-named files
-  - pre-creates nesting directories
  .
  rclone
  ~~~~~~
@@ -160,6 +161,33 @@
   - URL: ``rclone:remote:path``, we just prefix "rclone:" and give all to the right
     of that to rclone, see: https://rclone.org/docs/#syntax-of-remote-paths
   - implementation of this primarily depends on the specific remote.
+  - rclone binary path can be set via the environment variable RCLONE_BINARY (default      value: "rclone")
+ .
+ s3
+ ~~
+ .
+ Use storage on an S3-compliant cloud service:
+ .
+  - URL: ``(s3|b2):[profile|(access_key_id:access_key_secret)@][schema://hostname[:p      ort]]/bucket/path``
+ .
+   The underlying backend is based on ``boto3``, so all standard boto3 authentication  methods are supported:
+ .
+    - provide a named profile (from your boto3 config),
+    - include access key ID and secret in the URL,
+    - or use default credentials (e.g., environment variables, IAM roles, etc.).
+ .
+   See the `boto3 credentials documentation <https://boto3.amazonaws.com/v1/documentation/api/latest/guide/credentials.html>`_ for more details.
+ .
+   If you're connecting to **AWS S3**, the ``[schema://hostname[:port]]`` part is optional.
+   Bucket and path are always required.
+ .
+   .. note::
+ .
+      There is a known issue with some S3-compatible services (e.g., **Backblaze B2**).
+      If you encounter problems, try using ``b2:`` instead of ``s3:`` in the url.
+ .
+   - namespaces: directories
+   - values: in key-named files
  .
  Scalability
  -----------
@@ -178,15 +206,20 @@
  Installation
  ------------
  .
- Install without the ``sftp:`` backend::
+ Install without the ``sftp:`` or ``s3:`` backend::
  .
      pip install borgstore
+     pip install "borgstore[none]"  # same thing (simplifies automation)
  .
  Install with the ``sftp:`` backend (more dependencies)::
  .
     pip install "borgstore[sftp]"
  .
- Please note that ``rclone:`` also supports sftp remotes.
+ Install with the ``s3:`` backend (more dependencies)::
+ .
+    pip install "borgstore[s3]"
+ .
+ Please note that ``rclone:`` also supports sftp or s3 remotes.
  .
  Want a demo?
  ------------
@@ -206,7 +239,7 @@
  There are tests and they succeed for the basic functionality, so some of the
  stuff is already working well.
  .
- There might be missing features or optimization potential, feedback welcome!
+ There might be missing features or optimization potential, feedback is welcome!
  .
  There are a lot of possible, but still missing backends. If you want to create
  and support one: pull requests are welcome.
