## borgstore 0.3.1

=== debian/changelog ===
borgstore (0.3.1-2) unstable; urgency=medium

  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 10:42:44 +0100

borgstore (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1
  * Bump std-version to 4.7.3
  * Update package description

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 10:41:21 +0100

borgstore (0.3.0-4) unstable; urgency=medium

  * Add python3-all to build depends to fix autopkgtest failures with new
    Python3.14 (Closes: #1123063)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Dec 2025 10:01:09 +0100

borgstore (0.3.0-3) unstable; urgency=medium

  * Drop R^3: no, default now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Nov 2025 08:37:54 +0100
